diff --git a/game/core/src/main/java/net/minecraft/core/world/WorldSource.java b/game/core/src/main/java/net/minecraft/core/world/WorldSource.java
index fc1ca427e..109828112 100644
--- a/game/core/src/main/java/net/minecraft/core/world/WorldSource.java
+++ b/game/core/src/main/java/net/minecraft/core/world/WorldSource.java
@@ -9,6 +9,7 @@ import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
 import net.minecraft.core.world.season.SeasonManager;
+import net.minecraft.core.world.type.WorldType;
 import net.minecraft.core.world.weather.WeatherManager;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
@@ -16,129 +17,131 @@ import org.jetbrains.annotations.Nullable;
 public interface WorldSource {
     int getHeightBlocks();
 
+    @NotNull Block<?> getBlockType(final @NotNull TilePosc tilePos);
+
+    @Nullable TileEntity getTileEntity(final @NotNull TilePosc tilePos);
+
+    default <T> @Nullable T getBlockLogic(final @NotNull TilePosc tilePos, final @NotNull Class<T> logicClass) {
+        final @NotNull Block<?> block = this.getBlockType(tilePos);
+        final @NotNull BlockLogic logic = block.getLogic();
+        if (logicClass.isAssignableFrom(logic.getClass())) {
+            return logicClass.cast(logic);
+        }
+
+        return null;
+    }
+
+    float getBrightness(final @NotNull TilePosc tilePos, final int lightEmission);
+
+    byte getLightIndex(final @NotNull TilePosc tilePos, final int lightEmission);
+
+    float getLightBrightness(final @NotNull TilePosc tilePos);
+
+    int getBlockData(final @NotNull TilePosc tilePos);
+
     @Deprecated
     default int getBlockId(final int x, final int y, final int z) {
         return this.getBlockType(new TilePos(x, y, z)).id();
     }
 
-    @NotNull Block<?> getBlockType(final @NotNull TilePosc tilePos);
+    @NotNull Material getBlockMaterial(final @NotNull TilePosc tilePos);
+
+    boolean isBlockOpaqueCube(final @NotNull TilePosc tilePos);
+
+    boolean isBlockNormalCube(final @NotNull TilePosc tilePos);
+
+    double getBlockTemperature(final @NotNull TilePosc tilePos);
+
+    double getBlockHumidity(final @NotNull TilePosc tilePos);
+
+    double getBlockVariety(final @NotNull TilePosc tilePos);
+
+    @NotNull SeasonManager getSeasonManager();
+
+    @NotNull WeatherManager getWeatherManager();
+
+    @NotNull Biome getBlockBiome(final @NotNull TilePosc tilePos);
+
+    int getSavedLightValue(final @NotNull LightLayer lightLayer, final @NotNull TilePosc tilePos);
+
+    byte getSavedLightIndex(@NotNull TilePosc tilePos);
+
+    @NotNull Dimension getDimension();
+
+    @NotNull WorldType getWorldType();
 
     @Deprecated
     default @NotNull Block<?> getBlock(final int x, final int y, final int z) {
         return this.getBlockType(new TilePos(x, y, z));
     }
 
-    @Nullable TileEntity getTileEntity(final @NotNull TilePosc tilePos);
-
     @Deprecated
     default @Nullable TileEntity getTileEntity(final int x, final int y, final int z) {
         return this.getTileEntity(new TilePos(x, y, z));
     }
 
-    default <T> @Nullable T getBlockLogic(final @NotNull TilePosc tilePos, final @NotNull Class<T> logicClass) {
-        final @NotNull Block<?> block = this.getBlockType(tilePos);
-        final @NotNull BlockLogic logic = block.getLogic();
-        if (logicClass.isAssignableFrom(logic.getClass())) {
-            return logicClass.cast(logic);
-        }
-
-        return null;
-    }
-
     @Deprecated
     default <T> @Nullable T getBlockLogic(final int x, final int y, final int z, final @NotNull Class<T> logicClass) {
         return this.getBlockLogic(new TilePos(x, y, z), logicClass);
     }
 
-    float getBrightness(final @NotNull TilePosc tilePos, final int lightEmission);
-
     @Deprecated
     default float getBrightness(final int x, final int y, final int z, final int lightEmission) {
         return this.getBrightness(new TilePos(x, y, z), lightEmission);
     }
 
-    byte getLightIndex(final @NotNull TilePosc tilePos, final int lightEmission);
-
     @Deprecated
     default byte getLightmapCoord(final int x, final int y, final int z, final int lightEmission) {
         return this.getLightIndex(new TilePos(x, y, z), lightEmission);
     }
 
-    float getLightBrightness(final @NotNull TilePosc tilePos);
-
     @Deprecated
     default float getLightBrightness(final int x, final int y, final int z) {
         return this.getLightBrightness(new TilePos(x, y, z));
     }
 
-    int getBlockData(final @NotNull TilePosc tilePos);
-
     @Deprecated
     default int getBlockMetadata(final int x, final int y, final int z) {
         return this.getBlockData(new TilePos(x, y, z));
     }
 
-    @NotNull Material getBlockMaterial(final @NotNull TilePosc tilePos);
-
     @Deprecated
     default @NotNull Material getBlockMaterial(final int x, final int y, final int z) {
         return this.getBlockMaterial(new TilePos(x, y, z));
     }
 
-    boolean isBlockOpaqueCube(final @NotNull TilePosc tilePos);
-
     @Deprecated
     default boolean isBlockOpaqueCube(final int x, final int y, final int z) {
         return this.isBlockOpaqueCube(new TilePos(x, y, z));
     }
 
-    boolean isBlockNormalCube(final @NotNull TilePosc tilePos);
-
     @Deprecated
     default boolean isBlockNormalCube(final int x, final int y, final int z) {
         return this.isBlockNormalCube(new TilePos(x, y, z));
     }
 
-    double getBlockTemperature(final @NotNull TilePosc tilePos);
-
     @Deprecated
     default double getBlockTemperature(final int x, final int z) {
         return this.getBlockTemperature(new TilePos(x, 0, z));
     }
 
-    double getBlockHumidity(final @NotNull TilePosc tilePos);
-
     @Deprecated
     default double getBlockHumidity(final int x, final int z) {
         return this.getBlockHumidity(new TilePos(x, 0, z));
     }
 
-    double getBlockVariety(final @NotNull TilePosc tilePos);
-
     @Deprecated
     default double getBlockVariety(final int x, final int z) {
         return this.getBlockVariety(new TilePos(x, 0, z));
     }
 
-    @NotNull SeasonManager getSeasonManager();
-
-    @NotNull WeatherManager getWeatherManager();
-
-    @NotNull Biome getBlockBiome(final @NotNull TilePosc tilePos);
-
     @Deprecated
-    default @Nullable Biome getBlockBiome(final int x, final int y, final int z) {
+    default @NotNull Biome getBlockBiome(final int x, final int y, final int z) {
         return this.getBlockBiome(new TilePos(x, y, z));
     }
 
-    int getSavedLightValue(final @NotNull LightLayer lightLayer, final @NotNull TilePosc tilePos);
-
-    byte getSavedLightIndex(@NotNull TilePosc tilePos);
-
     @Deprecated
     default int getSavedLightValue(final @NotNull LightLayer layer, final int x, final int y, final int z) {
         return this.getSavedLightValue(layer, new TilePos(x, y, z));
     }
-
-    boolean isRetro();
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/Biome.java b/game/core/src/main/java/net/minecraft/core/world/biome/Biome.java
index 8f3503e9d..28ade554b 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/Biome.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/Biome.java
@@ -1,6 +1,8 @@
 package net.minecraft.core.world.biome;
 
 import net.minecraft.core.block.Blocks;
+import net.minecraft.core.data.tag.ITaggable;
+import net.minecraft.core.data.tag.Tag;
 import net.minecraft.core.entity.SpawnListEntry;
 import net.minecraft.core.entity.animal.MobButterfly;
 import net.minecraft.core.entity.animal.MobChicken;
@@ -27,140 +29,131 @@ import net.minecraft.core.world.pos.TilePosc;
 import net.minecraft.core.world.weather.Weather;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.jetbrains.annotations.Range;
 
 import java.util.ArrayList;
+import java.util.Arrays;
 import java.util.List;
 import java.util.Random;
 
 public class Biome
-{
-	public final String translationKey;
+    implements ITaggable<Biome> {
+
+    public final @NotNull String translationKey;
     public int color = 0xFF00FF;
-    public short topBlock;
-    public short fillerBlock;
-    public Weather[] blockedWeathers = new Weather[0];
-    protected @NotNull List<@NotNull SpawnListEntry> spawnableMonsterList = new ArrayList<>();
-    protected @NotNull List<@NotNull SpawnListEntry> spawnableCreatureList = new ArrayList<>();
-    protected @NotNull List<@NotNull SpawnListEntry> spawnableWaterCreatureList = new ArrayList<>();
-    protected @NotNull List<@NotNull SpawnListEntry> spawnableAmbientCreatureList = new ArrayList<>();
-    private boolean hasSurfaceSnow = false;
-    private boolean hasSurfaceIce = false;
+    public final @NotNull List<@NotNull Weather> blockedWeathers = new ArrayList<>();
+    protected final @NotNull List<@NotNull SpawnListEntry> spawnableMonsterList = new ArrayList<>();
+    protected final @NotNull List<@NotNull SpawnListEntry> spawnableCreatureList = new ArrayList<>();
+    protected final @NotNull List<@NotNull SpawnListEntry> spawnableWaterCreatureList = new ArrayList<>();
+    protected final @NotNull List<@NotNull SpawnListEntry> spawnableAmbientCreatureList = new ArrayList<>();
     public float defaultTemperature = 0.5f;
     public float defaultHumidity = 0.5f;
     public float defaultVariety = 0.5f;
-    
-    public Biome(String key)
-    {
-    	this.translationKey = "biome." + key;
-        this.topBlock = (short) Blocks.GRASS.id();
-        this.fillerBlock = (short)Blocks.DIRT.id();
-        this.spawnableMonsterList.add(new SpawnListEntry(MobSpider.class, 10));
-        this.spawnableMonsterList.add(new SpawnListEntry(MobZombie.class, 10));
-        this.spawnableMonsterList.add(new SpawnListEntry(MobZombieArmored.class, 2));
-        this.spawnableMonsterList.add(new SpawnListEntry(MobSkeleton.class, 10));
-        this.spawnableMonsterList.add(new SpawnListEntry(MobCreeper.class, 10));
-        this.spawnableMonsterList.add(new SpawnListEntry(MobSlime.class, 10));
-        this.spawnableMonsterList.add(new SpawnListEntry(MobSnowman.class, 2));
-        this.spawnableCreatureList.add(new SpawnListEntry(MobSheep.class, 102));
-        this.spawnableCreatureList.add(new SpawnListEntry(MobPig.class, 102));
-        this.spawnableCreatureList.add(new SpawnListEntry(MobChicken.class, 102));
-        this.spawnableCreatureList.add(new SpawnListEntry(MobCow.class, 102));
-        this.spawnableCreatureList.add(new SpawnListEntry(MobDeer.class, 10));
-        this.spawnableWaterCreatureList.add(new SpawnListEntry(MobSquid.class, 10));
-        this.spawnableAmbientCreatureList.add(new SpawnListEntry(MobFireflyCluster.class, 10));
-        this.spawnableAmbientCreatureList.add(new SpawnListEntry(MobButterfly.class, 65));
+    private @NotNull SurfaceProperties surfaceProperties;
+
+    public Biome(final @NotNull String key) {
+        this.translationKey = "biome." + key;
+        this.surfaceProperties = new SurfaceProperties.Builder().build();
+        Biome.initSpawnables(
+            this.spawnableMonsterList,
+            this.spawnableCreatureList,
+            this.spawnableWaterCreatureList,
+            this.spawnableAmbientCreatureList
+        );
+    }
+
+    static void initSpawnables(
+        final @NotNull List<@NotNull SpawnListEntry> monsters,
+        final @NotNull List<@NotNull SpawnListEntry> creatures,
+        final @NotNull List<@NotNull SpawnListEntry> waterCreatures,
+        final @NotNull List<@NotNull SpawnListEntry> ambientCreatures
+    ) {
+        monsters.add(new SpawnListEntry(MobSpider.class, 10));
+        monsters.add(new SpawnListEntry(MobZombie.class, 10));
+        monsters.add(new SpawnListEntry(MobZombieArmored.class, 2));
+        monsters.add(new SpawnListEntry(MobSkeleton.class, 10));
+        monsters.add(new SpawnListEntry(MobCreeper.class, 10));
+        monsters.add(new SpawnListEntry(MobSlime.class, 10));
+        monsters.add(new SpawnListEntry(MobSnowman.class, 2));
+        creatures.add(new SpawnListEntry(MobSheep.class, 102));
+        creatures.add(new SpawnListEntry(MobPig.class, 102));
+        creatures.add(new SpawnListEntry(MobChicken.class, 102));
+        creatures.add(new SpawnListEntry(MobCow.class, 102));
+        creatures.add(new SpawnListEntry(MobDeer.class, 10));
+        waterCreatures.add(new SpawnListEntry(MobSquid.class, 10));
+        ambientCreatures.add(new SpawnListEntry(MobFireflyCluster.class, 10));
+        ambientCreatures.add(new SpawnListEntry(MobButterfly.class, 65));
     }
 
-    public @NotNull Biome setDefaults(final float temperature, final float humidity, final float variety) {
+    public @NotNull Biome withPlacementDefaults(final float temperature, final float humidity, final float variety) {
         this.defaultTemperature = temperature;
         this.defaultHumidity = humidity;
         this.defaultVariety = variety;
         return this;
     }
 
-    public WorldFeature getRandomWorldGenForTrees(Random random)
-    {
-        if(random.nextInt(10) == 0)
-        {
-            return new WorldFeatureTreeFancy(Blocks.LEAVES_OAK.id(), Blocks.LOG_OAK.id());
-        } else
-        {
-            return new WorldFeatureTree(Blocks.LEAVES_OAK.id(), Blocks.LOG_OAK.id(), 4);
+    @SafeVarargs
+    public final @NotNull Biome withTags(final @NotNull Tag<Biome>... tags) {
+        for (final @NotNull Tag<Biome> tag : tags) {
+            tag.tag(this);
         }
+
+        return this;
     }
 
-    public Biome setColor(int color)
-    {
+    public @NotNull Biome withDebugColor(final int color) {
         this.color = color;
         return this;
     }
 
-    public int getSkyColor(float temperature)
-    {
+    public @NotNull Biome withBlockedWeathers(final @NotNull Weather... blocked) {
+        this.blockedWeathers.clear();
+        this.blockedWeathers.addAll(Arrays.asList(blocked));
+        return this;
+    }
+
+    public @NotNull Biome withSurfaceProperties(final @NotNull SurfaceProperties surfaceProperties) {
+        this.surfaceProperties = surfaceProperties;
+        return this;
+    }
+
+    public @NotNull SurfaceProperties getSurfaceProperties() {
+        return this.surfaceProperties;
+    }
+
+    public @NotNull WorldFeature getTreeFeature(final @NotNull Random random) {
+        if (random.nextInt(10) == 0) {
+            return new WorldFeatureTreeFancy(Blocks.LEAVES_OAK.id(), Blocks.LOG_OAK.id());
+        } else {
+            return new WorldFeatureTree(Blocks.LEAVES_OAK.id(), Blocks.LOG_OAK.id(), 4);
+        }
+    }
+
+    public int getSkyColor(float temperature) {
         temperature /= 3F;
-        if(temperature < -1F)
-        {
+        if (temperature < -1F) {
             temperature = -1F;
         }
-        if(temperature > 1.0F)
-        {
+        if (temperature > 1.0F) {
             temperature = 1.0F;
         }
+        // todo: remove AWT dependency
         return java.awt.Color.getHSBColor(0.6222222F - temperature * 0.125F, 0.5F + temperature * 0.1F, 1.0F).getRGB();
     }
 
-    public @NotNull List<@NotNull SpawnListEntry> getSpawnableList(final @NotNull MobCategory creatureType)
-    {
-        return switch (creatureType) {
+    public @NotNull List<@NotNull SpawnListEntry> getSpawnableList(final @NotNull MobCategory category) {
+        return switch (category) {
             case MONSTER -> this.spawnableMonsterList;
             case CREATURE -> this.spawnableCreatureList;
             case WATER_CREATURE -> this.spawnableWaterCreatureList;
             case AMBIENT -> this.spawnableAmbientCreatureList;
         };
     }
-    
-    public boolean hasSurfaceSnow()
-    {
-    	return this.hasSurfaceSnow;
-    }
-
-    public boolean hasSurfaceIce() {
-        return this.hasSurfaceIce;
-    }
-
-    public Biome setSurfaceSnow()
-    {
-        this.hasSurfaceSnow = true;
-    	return this;
-    }
-
-    public Biome setSurfaceIce() {
-        this.hasSurfaceIce = true;
-        return this;
-    }
-
-    public Biome setBlockedWeathers(Weather... blocked)
-    {
-    	this.blockedWeathers = blocked;
-    	return this;
-    }
 
-    public Biome setTopBlock(int id)
-    {
-        this.topBlock = (short)id;
-        return this;
-    }
-
-    public Biome setFillerBlock(int id)
-    {
-        this.fillerBlock = (short)id;
-        return this;
-    }
-
-    public static @Nullable TilePosc getBiomeCoords(@NotNull Biome biome, @NotNull World world) {
-        int[] xPattern = new int[]{0, 1, 0, -1};
-        int[] zPattern = new int[]{1, 0, -1, 0};
-        TilePosc sourcePos = new TilePos();
+    public static @Nullable TilePosc getBiomeCoords(final @NotNull Biome biome, final @NotNull World world) {
+        final int[] xPattern = new int[]{0, 1, 0, -1};
+        final int[] zPattern = new int[]{1, 0, -1, 0};
+        final @NotNull TilePosc sourcePos = new TilePos();
         int runLength = 2;
         int chunkX = (int) (sourcePos.x() / 16.0);
         int chunkZ = (int) (sourcePos.z() / 16.0);
@@ -187,4 +180,13 @@ public class Biome
             return null;
         }
     }
+
+    public boolean hasTag(final @NotNull Tag<Biome> tag) {
+        return tag.appliesTo(this);
+    }
+
+    @Override
+    public boolean isIn(final @NotNull Tag<Biome> tag) {
+        return tag.appliesTo(this);
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/BiomeTags.java b/game/core/src/main/java/net/minecraft/core/world/biome/BiomeTags.java
new file mode 100644
index 000000000..d54ebafec
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/BiomeTags.java
@@ -0,0 +1,50 @@
+package net.minecraft.core.world.biome;
+
+import net.minecraft.core.data.tag.Tag;
+import org.jetbrains.annotations.NotNull;
+
+public final class BiomeTags {
+    private BiomeTags() throws IllegalAccessException {
+        throw new IllegalAccessException("Attempted instantiation of helper class!");
+    }
+
+    /**
+     * Defines whether the biome has a coating of surface snow.
+     */
+    public static final @NotNull Tag<Biome> HAS_SURFACE_SNOW = Tag.of("has_surface_snow");
+
+    /**
+     * Defines whether the biome has a coating of surface ash.
+     */
+    public static final @NotNull Tag<Biome> HAS_SURFACE_ASH = Tag.of("has_surface_ash");
+
+    /**
+     * Defines whether surface water freezes in this biome.
+     */
+    public static final @NotNull Tag<Biome> HAS_SURFACE_ICE = Tag.of("has_surface_ice");
+
+    /**
+     * Defines whether sulfur pools generate on the surface of this biome.
+     */
+    public static final @NotNull Tag<Biome> HAS_SULFUR_POOLS = Tag.of("has_sulfur_pools");
+
+    /**
+     * Defines whether this biome has crystal veins.
+     */
+    public static final @NotNull Tag<Biome> HAS_CRYSTAL_VEINS = Tag.of("has_crystal_veins");
+
+    /**
+     * Defines whether this biome has surface water, e.g. swamps.
+     */
+    public static final @NotNull Tag<Biome> HAS_SURFACE_WATER = Tag.of("has_surface_water");
+
+    /**
+     * Defines whether this biome spawns with a muddy surface.
+     */
+    public static final @NotNull Tag<Biome> HAS_SURFACE_MUD = Tag.of("has_surface_mud");
+
+    /**
+     * Defines whether snow constantly layers up in this biome regardless of season.
+     */
+    public static final @NotNull Tag<Biome> DEEPER_SNOW = Tag.of("deeper_snow");
+}
